package com.supwisdom.dlpay.framework.dao;

import com.supwisdom.dlpay.framework.data.SystemDateTime;
import com.supwisdom.dlpay.framework.domain.TTaskLock;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;

@Repository
public interface TaskLockDao extends JpaRepository<TTaskLock, String> {

  @Lock(LockModeType.PESSIMISTIC_WRITE)
  @Query("select a from TTaskLock a where a.taskcode=:taskcode")
  TTaskLock getTaskLockWithLock(@Param("taskcode") String taskcode);

  //================= database=Oracle =================//
  @Query(value = "select  to_char(sysdate,'yyyymmdd') as hostdate,to_char(sysdate,'hh24miss') as hosttime,to_char(sysdate,'yyyymmddhh24miss') as hostdatetime, sysdate from dual", nativeQuery = true)
  SystemDateTime getOracleDatetime();

  @Query(value = " select to_char(sysdate,'yyyyMMddhh24miss')||to_char(SEQ_REFNO.nextval,'FM000000') as billno from dual ", nativeQuery = true)
  String getOracleRefno();




  //================= database=PG =================//
  @Query(value = " select to_char(CURRENT_TIMESTAMP,'yyyyMMddhh24miss')||to_char(nextval('SEQ_REFNO'),'FM000000') as billno ", nativeQuery = true)
  String getPgRefno();
}
